searchNodes=[{"doc":"An extensible client for connecting to GraphQL websockets that are implemented following the graphql-ws conventions. Example Send a query or mutation and return the result immediately: { :ok , result } = GraphQLWSClient . query ( socket , &quot;query GetPost { ... }&quot; ) Register a subscription to listen for events: { :ok , subscription_id } = GraphQLWSClient . subscribe ( socket , &quot;subscription PostCreated { ... }&quot; ) GraphQLWSClient . query! ( socket , &quot;mutation CreatePost { ... }&quot; ) receive do % GraphQLWSClient.Event { type : :error , id : ^ subscription_id , payload : error } -&gt; IO . inspect ( error , label : &quot;error&quot; ) % GraphQLWSClient.Event { type : :next , id : ^ subscription_id , payload : result } -&gt; IO . inspect ( result ) % GraphQLWSClient.Event { type : :complete , id : ^ subscription_id } -&gt; IO . puts ( &quot;Stream closed&quot; ) end GraphQLClient . close ( socket ) You would usually put this inside of a custom GenServer and handle the events in handle_info/3 . Alternatively, you can create a stream of results: socket |&gt; GraphQLWSClient . stream! ( &quot;subscription PostCreated { ... }&quot; ) |&gt; Stream . each ( fn result -&gt; IO . inspect ( result ) end ) |&gt; Stream . run ( ) Custom Client If you want to run the client as part of a supervision tree in your application, you can also use GraphQLWSClient to create your own client. defmodule MyClient do use GraphQLWSClient , otp_app : :my_app end Then, you can configure your client using a config file: import Config config :my_app , MyClient , url : &quot;ws://localhost:4000/socket&quot; See GraphQLWSClient.Config.new/1 for a list of available options.","ref":"GraphQLWSClient.html","title":"GraphQLWSClient","type":"module"},{"doc":"The default child specification that can be used to run the client under a supervisor.","ref":"GraphQLWSClient.html#child_spec/1","title":"GraphQLWSClient.child_spec/1","type":"function"},{"doc":"Closes the connection to the websocket.","ref":"GraphQLWSClient.html#close/1","title":"GraphQLWSClient.close/1","type":"function"},{"doc":"Indicates whether the client is connected to the Websocket.","ref":"GraphQLWSClient.html#connected?/1","title":"GraphQLWSClient.connected?/1","type":"function"},{"doc":"Opens the connection to the websocket.","ref":"GraphQLWSClient.html#open/1","title":"GraphQLWSClient.open/1","type":"function"},{"doc":"Opens the connection to the websocket. Raises on error.","ref":"GraphQLWSClient.html#open!/1","title":"GraphQLWSClient.open!/1","type":"function"},{"doc":"Opens the connection to the websocket using a custom payload.","ref":"GraphQLWSClient.html#open_with/2","title":"GraphQLWSClient.open_with/2","type":"function"},{"doc":"Opens the connection to the websocket using a custom payload. Raises on error.","ref":"GraphQLWSClient.html#open_with!/2","title":"GraphQLWSClient.open_with!/2","type":"function"},{"doc":"Sends a GraphQL query or mutation to the websocket and returns the result. Example iex&gt; GraphQLWSClient . query ( ...&gt; client , ...&gt; &quot;query GetPost($id: ID!) { post(id: $id) { body } }&quot; , ...&gt; %{ &quot;id&quot; =&gt; 1337 } ...&gt; ) { :ok , %{ &quot;data&quot; =&gt; %{ &quot;posts&quot; =&gt; %{ &quot;body&quot; =&gt; &quot;Lorem Ipsum&quot; } } } }","ref":"GraphQLWSClient.html#query/4","title":"GraphQLWSClient.query/4","type":"function"},{"doc":"Sends a GraphQL query or mutation to the websocket and returns the result. Raises on error. Example iex&gt; GraphQLWSClient . query! ( ...&gt; client , ...&gt; &quot;query GetPost($id: ID!) { post(id: $id) { body } }&quot; , ...&gt; %{ &quot;id&quot; =&gt; 1337 } ...&gt; ) %{ &quot;data&quot; =&gt; %{ &quot;posts&quot; =&gt; %{ &quot;body&quot; =&gt; &quot;Lorem Ipsum&quot; } } }","ref":"GraphQLWSClient.html#query!/4","title":"GraphQLWSClient.query!/4","type":"function"},{"doc":"Starts a GraphQL Websocket client. Options See GraphQLWSClient.Config.new/1 for a list of available options. Additionally, you may pass GenServer.options/0 .","ref":"GraphQLWSClient.html#start_link/1","title":"GraphQLWSClient.start_link/1","type":"function"},{"doc":"Starts a GraphQL Websocket client using the given config and GenServer options. Options The first argument accept options as specified in GraphQLWSClient.Config.new/1 . The second argument accepts GenServer.options/0 .","ref":"GraphQLWSClient.html#start_link/2","title":"GraphQLWSClient.start_link/2","type":"function"},{"doc":"Sends a GraphQL subscription to the websocket and returns an event stream. Options :buffer_size - Sets the buffer size. If the buffer is exceeded, the oldest events are discarded first. Although it is not recommended, you may also set the value to :infinity to set no limit. Defaults to 1000 . Example iex&gt; stream = GraphQLWSClient . stream! ( ...&gt; client , ...&gt; &quot;&quot;&quot; ...&gt; subscription CommentAdded($postId: ID!) { ...&gt; commentAdded(postId: $postId) { body } ...&gt; } ...&gt; &quot;&quot;&quot; , ...&gt; %{ &quot;postId&quot; =&gt; 1337 } ...&gt; ) Print events as they come in: iex&gt; stream ...&gt; |&gt; Stream . each ( fn result -&gt; IO . inspect ( result ) end ) ...&gt; |&gt; Stream . run ( ) Wait for a fixed number of events to come in and then turn them into a list: iex&gt; stream |&gt; Stream . take ( 3 ) |&gt; Enum . to_list ( )","ref":"GraphQLWSClient.html#stream!/4","title":"GraphQLWSClient.stream!/4","type":"function"},{"doc":"Sends a GraphQL subscription to the websocket and registers a listener process to retrieve events. Example iex&gt; GraphQLWSClient . subscribe ( ...&gt; client , ...&gt; &quot;&quot;&quot; ...&gt; subscription CommentAdded($postId: ID!) { ...&gt; commentAdded(postId: $postId) { body } ...&gt; } ...&gt; &quot;&quot;&quot; , ...&gt; %{ &quot;postId&quot; =&gt; 1337 } ...&gt; ) { :ok , &quot;17f13976-f6a4-4c0a-8993-5b38017c2720&quot; }","ref":"GraphQLWSClient.html#subscribe/4","title":"GraphQLWSClient.subscribe/4","type":"function"},{"doc":"Sends a GraphQL subscription to the websocket and registers a listener process to retrieve events. Raises on error. Example iex&gt; GraphQLWSClient . subscribe! ( ...&gt; client , ...&gt; &quot;&quot;&quot; ...&gt; subscription CommentAdded($postId: ID!) { ...&gt; commentAdded(postId: $postId) { body } ...&gt; } ...&gt; &quot;&quot;&quot; , ...&gt; %{ &quot;postId&quot; =&gt; 1337 } ...&gt; ) &quot;df418a14-5673-4b37-8b71-7208cb32751d&quot;","ref":"GraphQLWSClient.html#subscribe!/4","title":"GraphQLWSClient.subscribe!/4","type":"function"},{"doc":"Removes a subscription. Example iex&gt; GraphQLWSClient . unsubscribe ( client , &quot;9248c790-cdb0-4707-aa6d-8ccc63955ceb&quot; ) :ok","ref":"GraphQLWSClient.html#unsubscribe/2","title":"GraphQLWSClient.unsubscribe/2","type":"function"},{"doc":"Removes a subscription. Raises on error. Example iex&gt; GraphQLWSClient . unsubscribe! ( client , &quot;9eb481c3-04cd-42c4-82b9-d52c67aa850b&quot; ) :ok","ref":"GraphQLWSClient.html#unsubscribe!/2","title":"GraphQLWSClient.unsubscribe!/2","type":"function"},{"doc":"Type for a client process.","ref":"GraphQLWSClient.html#t:client/0","title":"GraphQLWSClient.client/0","type":"type"},{"doc":"Type for a query, mutation or subscription string.","ref":"GraphQLWSClient.html#t:query/0","title":"GraphQLWSClient.query/0","type":"type"},{"doc":"Type for a subscription ID.","ref":"GraphQLWSClient.html#t:subscription_id/0","title":"GraphQLWSClient.subscription_id/0","type":"type"},{"doc":"Type for variables that are interpolated into the query.","ref":"GraphQLWSClient.html#t:variables/0","title":"GraphQLWSClient.variables/0","type":"type"},{"doc":"A struct containing the configuration for a client.","ref":"GraphQLWSClient.Config.html","title":"GraphQLWSClient.Config","type":"module"},{"doc":"Builds a new config. Options :backoff_interval - The number of milliseconds to wait before trying to reconnect to the server. :connect_on_start - Determines whether to immediately connect to the server as soon as the client is started. When set to false , you need to manually connect by calling GraphQLWSClient.open/1 . Defaults to true . :driver - The driver module to use. Defaults to GraphQLWSClient.Drivers.Gun . Can be either a module or a tuple in the form of {MyDriverModule, opt_a: &quot;hello world&quot;} . The options are passed to the driver's init/1 callback, if defined. :host - The host to connect to. This is ignored when :url is specified instead. :init_payload - The payload send together with the connection_init message. Is useful when you need to authenticate a connection with a token, for instance. :path - The path on the server. This is ignored when :url is specified instead. Defaults to &quot;/&quot; . :port - The port to connect to. This is ignored when :url is specified instead. :query_timeout - The default query timeout in milliseconds. Defaults to 5000 . :url - The URL of the websocket to connect to. Overwrites the :host , :port and :path options.","ref":"GraphQLWSClient.Config.html#new/1","title":"GraphQLWSClient.Config.new/1","type":"function"},{"doc":"","ref":"GraphQLWSClient.Config.html#t:t/0","title":"GraphQLWSClient.Config.t/0","type":"type"},{"doc":"A event for a subscription. The struct consists of these fields: :payload - Either the result, an error or nil , dependent on the :type field. :subscription_id - A UUID identifying the subscription. This matches the subscription ID that is returned by GraphQLWSClient.subscribe/3 . :type - Indicates whether the event contains payload data ( :next ), there is no more data to receive ( :complete ) or an error occurred ( :error ).","ref":"GraphQLWSClient.Event.html","title":"GraphQLWSClient.Event","type":"module"},{"doc":"","ref":"GraphQLWSClient.Event.html#t:complete/0","title":"GraphQLWSClient.Event.complete/0","type":"type"},{"doc":"","ref":"GraphQLWSClient.Event.html#t:error/0","title":"GraphQLWSClient.Event.error/0","type":"type"},{"doc":"","ref":"GraphQLWSClient.Event.html#t:next/0","title":"GraphQLWSClient.Event.next/0","type":"type"},{"doc":"","ref":"GraphQLWSClient.Event.html#t:t/0","title":"GraphQLWSClient.Event.t/0","type":"type"},{"doc":"A struct passed to the used driver that contains information about the current connection.","ref":"GraphQLWSClient.Conn.html","title":"GraphQLWSClient.Conn","type":"module"},{"doc":"","ref":"GraphQLWSClient.Conn.html#t:t/0","title":"GraphQLWSClient.Conn.t/0","type":"type"},{"doc":"A behaviour that defines function to implement custom backends. Customize Options To customize the options that are used by the driver, you can set a custom :driver tuple when starting the client. GraphQLWSClient . start_link ( host : &quot;example.com&quot; , driver : { GraphQLWSClient.Drivers.Gun , json_library : Poison } , ) Or you can set it in the configuration for your custom client. import Config config :my_app , MyGraphQLWSClient , driver : { GraphQLWSClient.Drivers.Gun , json_library : Poison }","ref":"GraphQLWSClient.Driver.html","title":"GraphQLWSClient.Driver","type":"behaviour"},{"doc":"Connects to the socket and returns the updated GraphQLWSClient.Conn .","ref":"GraphQLWSClient.Driver.html#c:connect/1","title":"GraphQLWSClient.Driver.connect/1","type":"callback"},{"doc":"Disconnects from the socket.","ref":"GraphQLWSClient.Driver.html#c:disconnect/1","title":"GraphQLWSClient.Driver.disconnect/1","type":"callback"},{"doc":"Optional callback that prepares the :opts stored in the GraphQLWSClient.Conn . Can be used to set default values.","ref":"GraphQLWSClient.Driver.html#c:init/1","title":"GraphQLWSClient.Driver.init/1","type":"callback"},{"doc":"Parses a message received from the socket.","ref":"GraphQLWSClient.Driver.html#c:parse_message/2","title":"GraphQLWSClient.Driver.parse_message/2","type":"callback"},{"doc":"Pushes a message to the socket.","ref":"GraphQLWSClient.Driver.html#c:push_message/2","title":"GraphQLWSClient.Driver.push_message/2","type":"callback"},{"doc":"A low-level message sent and received by drivers.","ref":"GraphQLWSClient.Message.html","title":"GraphQLWSClient.Message","type":"module"},{"doc":"","ref":"GraphQLWSClient.Message.html#t:message_type/0","title":"GraphQLWSClient.Message.message_type/0","type":"type"},{"doc":"","ref":"GraphQLWSClient.Message.html#t:t/0","title":"GraphQLWSClient.Message.t/0","type":"type"},{"doc":"A driver using the :gun library to connect to the GraphQL websocket. Usage The Gun driver is configured as default driver using Jason as default encoder and decoder. However, you still need to install the particular libraries yourself if you want to use them, so add these to your deps. { :gun , &quot;~&gt; 2.0&quot; } , { :jason , &quot;~&gt; 1.4&quot; } , Available Options See GraphQLWSClient.Driver to find out how to pass options to the driver. :ack_timeout - The number of milliseconds to wait for a connection_ack after initiating the connection. Defaults to 5000 . :connect_options - Connection options forwarded to :gun.open/3 . See :gun.opts/0 for all available options. :json_library - The library used to encode and decode JSON payloads. Jason by default. :upgrade_timeout - The number of milliseconds to wait for a connection upgrade. Defaults to 5000 .","ref":"GraphQLWSClient.Drivers.Gun.html","title":"GraphQLWSClient.Drivers.Gun","type":"module"},{"doc":"Exception that contains errors from a GraphQL query.","ref":"GraphQLWSClient.GraphQLError.html","title":"GraphQLWSClient.GraphQLError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"GraphQLWSClient.GraphQLError.html#message/1","title":"GraphQLWSClient.GraphQLError.message/1","type":"function"},{"doc":"","ref":"GraphQLWSClient.GraphQLError.html#t:t/0","title":"GraphQLWSClient.GraphQLError.t/0","type":"type"},{"doc":"An error that indicates an invalid operation.","ref":"GraphQLWSClient.OperationError.html","title":"GraphQLWSClient.OperationError","type":"exception"},{"doc":"Exception that indicates a socket error.","ref":"GraphQLWSClient.SocketError.html","title":"GraphQLWSClient.SocketError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"GraphQLWSClient.SocketError.html#message/1","title":"GraphQLWSClient.SocketError.message/1","type":"function"},{"doc":"","ref":"GraphQLWSClient.SocketError.html#t:cause/0","title":"GraphQLWSClient.SocketError.cause/0","type":"type"},{"doc":"","ref":"GraphQLWSClient.SocketError.html#t:t/0","title":"GraphQLWSClient.SocketError.t/0","type":"type"},{"doc":"MIT License Copyright (c) 2023 Tobias Casper Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"An extensible client for connecting with GraphQL over Websockets following the graphql-ws conventions.","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"The package can be installed by adding graphql_ws_client to your list of dependencies in mix.exs . def deps do [ { :graphql_ws_client , &quot;~&gt; 2.0&quot; } , ] end If you are using the default configuration, GraphQLWSClient.Drivers.Gun is used as driver and you will need the gun and jason packages as well. def deps do [ # ... { :gun , &quot;~&gt; 2.0&quot; } , { :jason , &quot;~&gt; 1.4&quot; } , ] end Take a look in the driver documentation to find out how to customize driver options. Alternatively, you can write your own driver based on the GraphQLWSClient.Driver behaviour.","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"Connect to a socket: { :ok , socket } = GraphQLWSClient . start_link ( url : &quot;ws://localhost:4000/socket&quot; ) Send a query or mutation and return the result immediately: { :ok , result } = GraphQLWSClient . query ( socket , &quot;query GetPost { ... }&quot; ) Register a subscription to listen for events: { :ok , subscription_id } = GraphQLWSClient . subscribe ( socket , &quot;subscription PostCreated { ... }&quot; ) GraphQLWSClient . query! ( socket , &quot;mutation CreatePost { ... }&quot; ) receive do % GraphQLWSClient.Event { type : :error , id : ^ subscription_id , payload : error } -&gt; IO . inspect ( error , label : &quot;error&quot; ) % GraphQLWSClient.Event { type : :next , id : ^ subscription_id , payload : result } -&gt; IO . inspect ( result ) % GraphQLWSClient.Event { type : :complete , id : ^ subscription_id } -&gt; IO . puts ( &quot;Stream closed&quot; ) end GraphQLClient . close ( socket ) You would usually put this inside of a custom GenServer and handle the events in handle_info/3 . Alternatively, you can create a stream of results: socket |&gt; GraphQLWSClient . stream! ( &quot;subscription PostCreated { ... }&quot; ) |&gt; Stream . each ( fn result -&gt; IO . inspect ( result ) end ) |&gt; Stream . run ( )","ref":"readme.html#usage","title":"Readme - Usage","type":"extras"},{"doc":"If you want to run the client as part of a supervision tree in your application, you can also use GraphQLWSClient to create your own client. defmodule MyClient do use GraphQLWSClient , otp_app : :my_app end Then, you can configure your client using a config file: import Config config :my_app , MyClient , url : &quot;ws://localhost:4000/socket&quot;","ref":"readme.html#custom-client","title":"Readme - Custom Client","type":"extras"},{"doc":"Documentation can be found at https://hexdocs.pm/graphql_ws_client or generated locally using mix docs .","ref":"readme.html#docs","title":"Readme - Docs","type":"extras"}]